/*
TASK: brkclk
LANG: C++
*/

#include <iostream>
#include <fstream>
#include <map>
#include <vector>
#include <iomanip>
using namespace std;

/*
------0------   ----0x01-----
|           |   |           |
|           |   |           |
1           2  0x02        0x04
|           |   |           |
|           |   |           |
------3------   -----0x08----
|           |   |           |
|           |   |           |
4           5  0x10        0x20
|           |   |           |
|           |   |           |
------6------   -----0x40----
*/

const int digits[10] = {
	0x77, /* 0 */
	0x24, /* 1 */
	0x5d, /* 2 */
	0x6d, /* 3 */
	0x2e, /* 4 */
	0x6b, /* 5 */
	0x7b, /* 6 */
	0x25, /* 7 */
	0x7f, /* 8 */
	0x6f, /* 9 */
};

const int loc[7][2] = {
	{ 0, 1 },
	{ 1, 0 },
	{ 1, 2 },
	{ 2, 1 },
	{ 3, 0 },
	{ 3, 2 },
	{ 4, 1 },
};

int ans;
int mask, see;

void InX(void)
{
	char t[4][5][5];
	for (int i = 0; i < 5; i++)
		for (int j = 0; j < 4; j++)
			cin >> t[j][i];
	mask = see = 0;
	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 7; j++)
		{
			char ch = t[i][loc[j][0]][loc[j][1]];
			if (ch != '.')
				mask |= (1 << (j + i*8));
			if (ch == '=' || ch == '#')
				see  |= (1 << (j + i*8));
		}
	}
}

int convert(int time)
{
	char buff[5];
	sprintf(buff, "%2d%02d", time / 60, time % 60);
	int res = 0;
	for (int i = 0; i < 4; i++) {
		if (buff[i] ==  ' ') continue;
		res |= digits[buff[i]-'0'] << (i*8);
	}
	return res;
}

int timemasks[1440];

void DoWork(void)
{
	vector<int> M;
	for (int i = 0; i < 1440; i++) {
		timemasks[i] = convert(i) & mask;
		if (timemasks[i] == see)
			M.push_back(i);
	}
	ans = 0;
	int bi, bj;
	for (unsigned i = 0; i < M.size(); i++)
		for (unsigned j = i + 1; j < M.size(); j++) {
			int x = M[i];
			int y = M[j];
			int t = 0;
			do {
				x = (x + 1) % 1440;
				y = (y + 1) % 1440;
				t++;
			} while (timemasks[x] == timemasks[y] && t < 1440);
			if (t > ans) {
				bi = M[i];
				bj = M[j];
				ans = t;
			}
			if (ans >= 1440) {
				ans = -1;
				return;
			}
		}
}

void OutX(void) {
	cout << ans << endl; 
}

int main(void)
{
	InX();
	DoWork();
	OutX();
	return 0;
}
